diff --git a/CHANGES b/CHANGES
index a99c91c..6e133f2 100644
--- a/CHANGES
+++ b/CHANGES
@@ -1,4 +1,11 @@
 
+Changes with nginx-catap 0.7.57.422.152eb14                      13 May 2009
+
+    *) Feature: add $crc32_<name> and $md5_<name> variables.
+
+    *) Workaround: update to new API.
+
+
 Changes with nginx 0.7.57                                        12 May 2009
 
     *) Bugfix: a segmentation fault occurred in worker process, if the
@@ -6,6 +13,11 @@ Changes with nginx 0.7.57                                        12 May 2009
        location; the bug had appeared in 0.7.56.
 
 
+Changes with nginx-catap 0.7.56.416.23ae853                      12 May 2009
+
+    *) Workaround: update to new API.
+
+
 Changes with nginx 0.7.56                                        11 May 2009
 
     *) Feature: nginx/Windows supports IPv6 in a "listen" directive of the
@@ -14,6 +26,11 @@ Changes with nginx 0.7.56                                        11 May 2009
     *) Bugfix: in ngx_http_image_filter_module.
 
 
+Changes with nginx-catap 0.7.55.413.757b2b8                      06 May 2009
+
+    *) Workaround: update to new API.
+
+
 Changes with nginx 0.7.55                                        06 May 2009
 
     *) Bugfix: the http_XXX parameters in "proxy_cache_use_stale" and
@@ -35,6 +52,11 @@ Changes with nginx 0.7.55                                        06 May 2009
        Thanks to Maxim Dounin.
 
 
+Changes with nginx-catap 0.7.54.410.c1e4c27                      02 May 2009
+
+    *) Workaround: update to new API.
+
+
 Changes with nginx 0.7.54                                        01 May 2009
 
     *) Feature: the ngx_http_image_filter_module.
@@ -57,6 +79,11 @@ Changes with nginx 0.7.54                                        01 May 2009
        appeared in 0.7.53.
 
 
+Changes with nginx-catap 0.7.53.405.2cacf5f                      28 Apr 2009
+
+    *) Feature: implement $uri_remainder.
+
+
 Changes with nginx 0.7.53                                        27 Apr 2009
 
     *) Change: now a log set by --error-log-path is created from the very
@@ -96,6 +123,12 @@ Changes with nginx 0.7.53                                        27 Apr 2009
        Thanks to Andrew Vorobyoff.
 
 
+Changes with nginx-catap 0.7.52.397.142c3b0                      20 Apr 2009
+
+    *) Feature: Stop write log for some period after have a problems
+       for write.
+
+
 Changes with nginx 0.7.52                                        20 Apr 2009
 
     *) Feature: the first native Windows binary release.
@@ -119,6 +152,13 @@ Changes with nginx 0.7.52                                        20 Apr 2009
        amd64, sparc, and ppc; the bug had appeared in 0.7.42.
 
 
+Changes with nginx-catap 0.7.51.389.54fa56f                      13 Apr 2009
+
+    *) Workaround: start without capabilities.
+
+    *) Workaround: merge config of valid_user.
+
+
 Changes with nginx 0.7.51                                        12 Apr 2009
 
     *) Feature: the "try_files" directive supports a response code in the
@@ -133,6 +173,29 @@ Changes with nginx 0.7.51                                        12 Apr 2009
        then virtual servers might not work; the bug had appeared in 0.7.39.
 
 
+Changes with nginx-catap 0.7.50.383.5ebfee6                      13 Apr 2009
+
+    *) Workaround: Remove root if enables capabilities.
+
+
+Changes with nginx-catap 0.7.50.382.db7bb21                      06 Apr 2009
+
+    *) Workaround: change a logic of ngx_http_limit_var_module.
+
+
+Changes with nginx-catap 0.7.50.372.3e47e0a                      06 Apr 2009
+
+    *) Workaround: module ngx_http_limit_var_module don't build with
+       debug options.
+
+
+Changes with nginx-catap 0.7.50.369.9031b49                      06 Apr 2009
+
+    *) Feature: add a module ngx_http_limit_var_module.
+
+    *) Workaround: cleanup ngx_http_auth_basic_module.
+
+
 Changes with nginx 0.7.50                                        06 Apr 2009
 
     *) Bugfix: the $arg_... variables did not work; the bug had appeared in
@@ -187,6 +250,18 @@ Changes with nginx 0.7.47                                        01 Apr 2009
        or try_files; the bug had appeared in 0.7.44.
 
 
+Changes with nginx-catap 0.7.46.349.1a86951                      30 Mar 2009
+
+    *) Feature: add $urlencode_<name> and $urldecode_<name> variables.
+
+    *) Feature: implement ngx_prealloc.
+
+    *) Workaround: rewrite capabilities support on linux with Igor
+       Sysoev remarks.
+
+    *) Workaround: enable MALLOC_PRODUCTION for jemalloc.
+
+
 Changes with nginx 0.7.46                                        30 Mar 2009
 
     *) Bugfix: the previous release tarball was incorrect.
@@ -240,6 +315,25 @@ Changes with nginx 0.7.44                                        23 Mar 2009
        did not work.
 
 
+Changes with nginx-catap 0.7.43.324.58ce66e                      18 Mar 2009
+
+    *) Feature: start use capabilities on linix for remove infinity
+       root on master process.
+
+    *) Workaround: add directives empty_gif_size to
+       ngx_http_empty_gif_module for change size of gif for response.
+
+    *) Workaround: add more CPU to --with-cpu-opt options.
+
+    *) Bugfix: add --with-obsd_malloc and --with-jemalloc options to
+       ./configure --help.
+
+    *) Bugfix: change type in ngx_sprintf from %P to %T for $pid.
+
+    *) Bugfix: fix segmentation fault if do not inizialize values by
+       is_bot directives.
+
+
 Changes with nginx 0.7.43                                        18 Mar 2009
 
     *) Bugfix: a request was handled incorrectly, if a "root" directive
@@ -283,6 +377,43 @@ Changes with nginx 0.7.41                                        11 Mar 2009
        Thanks to Vladimir Sopot.
 
 
+Changes with nginx-catap 0.7.40.299.6838363                      10 Mar 2009
+
+    *) Feature: partial support ETag (only if-modify).
+
+    *) Feature: add $timestamp.
+
+    *) Feature: valid_user directive for the module
+       ngx_http_auth_basic_module points to a list of allowable users.
+
+    *) Feature: upstream_count_limit directive for limiting number of
+       moves in the case of an error backend in upstream.
+
+    *) Feature: two new alloc. obsd-like switch on over
+       --with-obsd_malloc, jemalloc over --with-jemalloc.
+
+    *) Feature: module ngx_http_is_bot.
+
+    *) Feature: opportunity to use gettimeofday created around
+       clock_gettime(NGX_CLOCK_PROFILE). The system is to be support
+       and turn over --with-clock_gettimeofday.
+
+    *) Feature: module ngx_http_response.
+
+    *) Feature: for loop in ssi.
+
+    *) Workaround: auth_basic_user_file directive support variables.
+
+    *) Workaround: for keepalive connections to the 204 No Content add
+       Content-Length: 0.
+
+    *) Workaround: module ngx_http_stub_status_module show count of
+       request per seconds.
+
+    *) Workaround: add support to acces to varriabless setting in ssi
+       over $ssi_<name>.
+
+
 Changes with nginx 0.7.40                                        09 Mar 2009
 
     *) Feature: the "location" directive supports captures in regular 
diff --git a/CHANGES.ru b/CHANGES.ru
index 98becbb..2bef1e9 100644
--- a/CHANGES.ru
+++ b/CHANGES.ru
@@ -1,4 +1,11 @@
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.57.422.152eb14                        13.05.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÄÏÂÁ×ÉÌÉÓØ ÐÅÒÅÍÅÎÎÙÅ $crc32_<ÉÍÑ> É $md5_<ÉÍÑ>.
+
+    *) éÚÍÅÎÅÎÉÑ: ÏÂÎÏ×ÌÅÎÉÅ ÄÏ ÎÏ×ÏÇÏ API.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.57                                          12.05.2009
 
     *) éÓÐÒÁ×ÌÅÎÉÅ: ÐÒÉ ÐÅÒÅÎÁÐÒÁ×ÌÅÎÉÉ ÏÛÉÂÏË ÍÏÄÕÌÑ
@@ -6,6 +13,11 @@
        ÐÒÏÃÅÓÓÅ ÐÒÏÉÓÈÏÄÉÌ floating-point fault; ÏÛÉÂËÁ ÐÏÑ×ÉÌÁÓØ × 0.7.56.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.56.416.23ae853                        12.05.2009
+
+    *) éÚÍÅÎÅÎÉÑ: ÏÂÎÏ×ÌÅÎÉÅ ÄÏ ÎÏ×ÏÇÏ API.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.56                                          11.05.2009
 
     *) äÏÂÁ×ÌÅÎÉÅ: nginx/Windows ÐÏÄÄÅÒÖÉ×ÁÅÔ IPv6 × ÄÉÒÅËÔÉ×Å listen
@@ -14,6 +26,11 @@
     *) éÓÐÒÁ×ÌÅÎÉÅ: × ÍÏÄÕÌÅ ngx_http_image_filter_module.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.55.413.757b2b8                        06.05.2009
+
+    *) éÚÍÅÎÅÎÉÑ: ÏÂÎÏ×ÌÅÎÉÅ ÄÏ ÎÏ×ÏÇÏ API.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.55                                          06.05.2009
 
     *) éÓÐÒÁ×ÌÅÎÉÅ: ÐÁÒÁÍÅÔÒÙ http_XXX × ÄÉÒÅËÔÉ×Å proxy_cache_use_stale É
@@ -35,6 +52,11 @@
        óÐÁÓÉÂÏ íÁËÓÉÍÕ äÕÎÉÎÕ.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.53.405.c1e4c27                        27.04.2009
+
+    *) éÚÍÅÎÅÎÉÑ: ÏÂÎÏ×ÌÅÎÉÅ ÄÏ ÎÏ×ÏÇÏ API.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.54                                          01.05.2009
 
     *) äÏÂÁ×ÌÅÎÉÅ: ÍÏÄÕÌØ ngx_http_image_filter_module.
@@ -56,6 +78,11 @@
        ÏÛÉÂËÁ ÐÏÑ×ÉÌÁÓØ × 0.7.53.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.53.405.2cacf5f                        27.04.2009
+
+    *) éÚÍÅÎÅÎÉÑ: ÄÏÂÁ×ÌÅÎÁ $uri_remainder
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.53                                          27.04.2009
 
     *) éÚÍÅÎÅÎÉÅ: ÔÅÐÅÒØ ÌÏÇ, ÕËÁÚÁÎÎÙÊ × --error-log-path, ÓÏÚÄÁ£ÔÓÑ Ó
@@ -95,6 +122,12 @@
        óÐÁÓÉÂÏ áÎÄÒÅÀ ÷ÏÒÏÂØ£×Õ.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.52.397.142c3b0                        20.04.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÐÅÒÅÓÔÁÅÍ ÐÉÓÁÔØ log ÎÁ ÎÅÂÏÌØÛÏÊ ÐÅÒÉÏÄ ×ÒÅÍÅÎÉ ×
+       ÓÌÕÞÁÅ ×ÏÚÎÉËÎÏ×ÅÎÉÑ ÐÒÏÂÌÅÍ.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.52                                          20.04.2009
 
     *) äÏÂÁ×ÌÅÎÉÅ: ÐÅÒ×ÁÑ ÂÉÎÁÒÎÁÑ ×ÅÒÓÉÑ ÐÏÄ Windows.
@@ -118,6 +151,13 @@
        amd64, sparc É ppc; ÏÛÉÂËÁ ÐÏÑ×ÉÌÁÓØ × 0.7.42.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.51.389.54fa56f                       06.04.2009
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÎÅ ÚÁÐÕÓÌÁËÓÑ ÅÓÌÉ ÎÅ ×ËÌÀÞÁÔØ capabilities.
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÓÌÉÑÎÉÅ ËÏÎÆÉÇÏ× ÔÅÒÑÌÏ valid_user.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.51                                          12.04.2009
 
     *) äÏÂÁ×ÌÅÎÉÅ: ÄÉÒÅËÔÉ×Á try_files ÐÏÄÄÅÒÖÉ×ÁÅÔ ËÏÄ ÏÔ×ÅÔÁ × ÐÏÓÌÅÄÎÅÍ
@@ -134,6 +174,29 @@
        × 0.7.39.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.50.382.5ebfee6                        06.04.2009
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÕÂÉÒÁÅÍ root ÐÒÉ×ÅÌÅÇÉÅ ÅÓÌÉ ×ËÌÀÞÅÎÙ capabilities.
+
+
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.50.382.db7bb21                        06.04.2009
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÉÚÍÅÎÅÎÉÑ ÌÏÇÉËÉ × ngx_http_limit_var_module.
+
+
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.50.372.3e47e0a                        06.04.2009
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÍÏÄÉÌØ ngx_http_limit_var_module ÎÅ ÓÏÂÉÒÁÌÓÑ ÐÒÉ
+       ×ËÌÀÞÅÎÏÍ debug.
+
+
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.50.369.9031b49                        06.04.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÄÏÂÁ×ÌÅÎ ÍÏÄÕÌØ ngx_http_limit_var_module.
+
+    *) éÚÍÅÎÅÎÉÅ: ÏÞÉÓÔËÁ ËÏÄÁ ngx_http_auth_basic_module.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.50                                          06.04.2009
 
     *) éÓÐÒÁ×ÌÅÎÉÅ: ÐÅÒÅÍÅÎÎÙÅ $arg_... ÎÅ ÒÁÂÏÔÁÌÉ; ÏÛÉÂËÁ ÐÏÑ×ÉÌÁÓØ ×
@@ -188,6 +251,18 @@
        ÐÏÍÏÝØÀ error_page ÉÌÉ try_files; ÏÛÉÂËÁ ÐÏÑ×ÉÌÁÓØ × 0.7.44.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.46.349.1a86951                        30.03.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÄÏÂÁ×ÌÅÎÙ ÐÅÒÅÍÅÎÎÙÅ $urlencode_<ÉÍÑ> É $urldecode_<ÉÍÑ>.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÒÅÁÌÉÚÏ×ÁÎ ngx_prealloc.
+
+    *) éÚÍÅÎÅÎÉÅ: ÐÅÒÅÐÉÓÁÎÁ ÐÏÄÄÅÒÖËÁ capabilities ÄÌÑ linux Ó ÕÞÅÔÏÍ
+       ÚÁÍÅÞÁÎÉÊ éÇÏÒÑ óÙÓÏÅ×Á.
+
+    *) éÚÍÅÎÅÎÉÅ: ×ËÌÀÞÅÎÉÅ MALLOC_PRODUCTION ÄÌÑ jemalloc.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.46                                          30.03.2009
 
     *) éÓÐÒÁ×ÌÅÎÉÅ: ÁÒÈÉ× ÐÒÅÄÙÄÕÝÅÇÏ ÒÅÌÉÚÁ ÂÙÌ ÎÅ×ÅÒÎÙÍ.
@@ -240,6 +315,25 @@
        ÒÁÂÏÔÁÌÉ.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.43.324.58ce66e                        18.03.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÎÁÞÁÌÉ ÉÓÐÏÌØÚÏ×ÁÔØ × Linux capabilities ÄÌÑ
+       ÐÏÎÉÖÅÎÉÑ ÐÒÉ×ÅÌÅÇÉÊ Õ master ÐÒÏÃÅÓÓÁ.
+
+    *) éÚÍÅÎÅÎÉÅ: ÄÏÂÁ×ÌÅÎÁ ÄÉÒÅËÔÉ×Á empty_gif_size ×
+       ngx_http_empty_gif_module ÄÌÑ ÉÚÍÅÎÅÎÉÑ ÒÁÚÍÅÒÁ gif × ÏÔ×ÅÔÅ.
+
+    *) éÚÍÅÎÅÎÉÅ: ÄÏÂÁ×ÌÅÎÏ ÂÏÌØÛÅ CPU × --with-cpu-opt options.
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÄÁÂÁ×ÌÅÎÙ ÏÐÃÉÉ --with-obsd_malloc É
+       --with-jemalloc × ./configure --help.
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÉÚÍÅÎÅÎ ÔÉÐ ÄÌÑ ngx_sprintf Ó %P ÎÁ %T ÄÌÑ $pid.
+
+    *) éÓÐÒÁ×ÌÅÎÉÅ: ÍÏÇ ÐÒÏÉÚÏÊÔÉ segmentation fault ÅÓÌÉ ÎÅ
+       ÉÎÉÃÉÁÌÉÚÉÒÏ×ÁÔØ ÚÎÁÞÅÎÉÅ × ÄÅÒÅËÔÉ×Å is_bot.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.43                                          18.03.2009
 
     *) éÓÐÒÁ×ÌÅÎÉÅ: ÚÁÐÒÏÓ ÏÂÒÁÂÁÔÙ×ÁÌÓÑ ÎÅ×ÅÒÎÏ, ÅÓÌÉ ÄÉÒÅËÔÉ×Á root
@@ -281,6 +375,46 @@
        óÐÁÓÉÂÏ ÷ÌÁÄÉÍÉÒÕ óÏÐÏÔÕ.
 
 
+éÚÍÅÎÅÎÉÑ × nginx-catap 0.7.40.299.6838363                        10.03.2009
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÞÁÓÔÉÞÎÁÑ ÐÏÄÄÅÒÖËÁ ETag (ÔÏÌØËÏ if-modify).
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÐÅÒÅÍÅÎÎÁÑ $timestamp.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÄÉÒÅËÔÉ×Á valid_user ÄÌÑ ÍÏÄÕÌÑ
+       ngx_http_auth_basic_module ÕËÁÚÙ×ÁÅÔ ÎÁ ÓÐÉÓÏË ÄÏÐÕÓÔÉÍÙÈ
+       ÐÏÌØÚÏ×ÁÔÅÌÅÊ.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÄÅÒÅËÔÉ×Á upstream_count_limit ÏÇÒÁÎÉÞÉ×ÁÅÔ
+       ËÏÌÉÞÅÓÔ×Ï ÐÅÒÅÂÉÒÁÅÍÙÈ × ÓÌÕÞÁÅ ÏÛÉÂËÉ ÂÜËÅÎÄÏ× × upstream'Å.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: Ä×Á ÎÏ×ÙÈ ÁÌÌÏËÁÔÏÒÁ. obsd-like ×ËÌÀÞÁÅÔÓÑ ÞÅÒÅÚ
+       --with-obsd_malloc, jemalloc ÞÅÒÅÚ --with-jemalloc.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÍÏÄÕÌØ ngx_http_is_bot.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ×ÏÚÍÏÖÎÏÓÔØ ÉÓÐÏÌØÚÏ×ÁÔØ gettimeofday ÓÏÚÄÁÎÎÙÊ
+       ×ÏËÒÕÇ clock_gettime(NGX_CLOCK_PROFILE). óÉÓÔÅÍÁ ÜÔÏ ÄÏÌÖÎÁ
+       ÐÏÄÄÅÒÖÉ×ÁÔØ É ÜÔÏ ÎÁÄÏ ×ËÌÀÞÉÔØ ÞÅÒÅÚ
+       --with-clock_gettimeofday.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÍÏÄÕÌØ ngx_http_response.
+
+    *) äÏÂÁ×ÌÅÎÉÅ: ÃÉËÌ for × ssi.
+
+    *) éÚÍÅÎÅÎÉÅ: ÄÅÒÅËÔÉ×Á auth_basic_user_file ÐÏÄÄÅÒÖÉ×ÁÅÔ ÔÅÐÅÒØ
+       ÐÅÒÅÍÅÎÎÙÅ.
+
+    *) éÚÍÅÎÅÎÉÅ: ÄÌÑ keepalive ÓÏÅÄÅÎÅÎÉÊ × 204 No Content ×ÙÄÁÅÔÓÑ
+       Content-Length: 0.
+
+    *) éÚÍÅÎÅÎÉÅ: ÍÏÄÕÌØ ngx_http_stub_status_module ÐÏËÁÚÙ×ÁÅÔ
+       ËÏÌÉÞÅÓÔ×Ï ÚÁÐÒÏÓÏ× × ÓÅËÕÎÄÕ.
+
+    *) éÚÍÅÎÅÎÉÅ: ×ÏÚÍÏÖÅÎ ÄÏÓÔÕÐ Ë ÐÅÒÅÍÅÎÎÙÍ ÕÓÔÁÎÏ×ÌÅÎÙÍ ÞÅÒÅÚ ssi
+       ÞÅÒÅÚ $ssi_<ÉÍÑ>.
+
+
 éÚÍÅÎÅÎÉÑ × nginx 0.7.40                                          09.03.2009
 
     *) äÏÂÁ×ÌÅÎÉÅ: ÄÉÒÅËÔÉ×Á location ÐÏÄÄÅÒÖÉ×ÁÅÔ ×ÙÄÅÌÅÎÉÑ × ÒÅÇÕÌÑÒÎÙÈ 
diff --git a/auto/cc/gcc b/auto/cc/gcc
index 8e5422e..a074aaa 100644
--- a/auto/cc/gcc
+++ b/auto/cc/gcc
@@ -74,6 +74,24 @@ case $CPU in
         NGX_CPU_CACHE_LINE=128
     ;;
 
+    prescott)
+        # optimize for Pentium 4, gcc 3.x
+        CPU_OPT="-march=prescott"
+        NGX_CPU_CACHE_LINE=128
+    ;;
+
+    nocona)
+        # optimize for Pentium 4, gcc 3.x
+        CPU_OPT="-march=pentium4"
+        NGX_CPU_CACHE_LINE=128
+    ;;
+
+    core2)
+        # optimize for Pentium 4, gcc 3.x
+        CPU_OPT="-march=pentium4"
+        NGX_CPU_CACHE_LINE=128
+    ;;
+
     athlon)
         # optimize for Athlon, gcc 3.x
         CPU_OPT="-march=athlon"
@@ -86,6 +104,18 @@ case $CPU in
         NGX_CPU_CACHE_LINE=64
     ;;
 
+    opteron-sse3)
+        # optimize for Opteron, gcc 4.x
+        CPU_OPT="-march=opteron-sse3"
+        NGX_CPU_CACHE_LINE=64
+    ;;
+
+    barcelona)
+        # optimize for Opteron, gcc 4.x
+        CPU_OPT="-march=barcelona"
+        NGX_CPU_CACHE_LINE=64
+    ;;
+
     sparc32)
         # build 32-bit UltraSparc binary
         CPU_OPT="-m32"
diff --git a/auto/lib/capabilities/conf b/auto/lib/capabilities/conf
new file mode 100644
index 0000000..a3207d4
--- /dev/null
+++ b/auto/lib/capabilities/conf
@@ -0,0 +1,19 @@
+
+# Copyright (C) Kirill A. Korinskiy
+
+
+ngx_feature="capabilities"
+ngx_feature_name="NGX_HAVE_CAPABILITIES"
+ngx_feature_run=no
+ngx_feature_incs="#include <sys/capability.h>"
+ngx_feature_path=
+ngx_feature_libs="-lcap"
+ngx_feature_test="cap_t caps;
+    caps = cap_get_proc();
+    return -1;"
+. auto/feature
+
+
+if [ $ngx_found = yes ]; then
+  CORE_LIBS="$CORE_LIBS $ngx_feature_libs"
+fi
diff --git a/auto/lib/clock/conf b/auto/lib/clock/conf
new file mode 100644
index 0000000..42ac841
--- /dev/null
+++ b/auto/lib/clock/conf
@@ -0,0 +1,62 @@
+
+# Copyright (C) Kirill A. Korinskiy
+
+
+  ngx_feature="clock_gettime"
+  ngx_feature_name="NGX_CLOCK"
+  ngx_feature_run=no
+  ngx_feature_incs="#include <time.h>"
+  ngx_feature_path=
+  ngx_feature_libs="-lrt"
+  ngx_feature_test="clock_gettime(NULL, NULL);"
+  . auto/feature
+
+
+if [ $ngx_found = yes ]; then
+    CORE_LIBS="$CORE_LIBS $ngx_feature_libs"
+
+  ngx_feature="CLOCK_REALTIME"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_VIRTUAL"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_MONOTONIC"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_PROCESS_CPUTIME_ID"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_THREAD_CPUTIME_ID"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_PROFILE"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_PROF"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+  ngx_feature="CLOCK_UPTIME"
+  ngx_feature_name="NGX_HAVE_$ngx_feature"
+  ngx_feature_test="clock_gettime($ngx_feature, NULL);"
+  . auto/feature
+
+fi
+
+if [ $NGX_CLOCK_GETTIMEOFDAY = YES ]; then
+  have=NGX_HAVE_CLOCK_GETTIMEOFDAY . auto/have
+fi
diff --git a/auto/lib/conf b/auto/lib/conf
index a4155e1..f30c6a5 100644
--- a/auto/lib/conf
+++ b/auto/lib/conf
@@ -56,3 +56,7 @@ fi
 if [ $NGX_GOOGLE_PERFTOOLS = YES ]; then
     . auto/lib/google-perftools/conf
 fi
+
+if [ $NGX_CLOCK = YES ]; then
+    . auto/lib/clock/conf
+fi
diff --git a/auto/modules b/auto/modules
index 9bc2e04..9999a20 100644
--- a/auto/modules
+++ b/auto/modules
@@ -217,6 +217,12 @@ if [ $HTTP_LIMIT_ZONE = YES ]; then
     HTTP_SRCS="$HTTP_SRCS $HTTP_LIMIT_ZONE_SRCS"
 fi
 
+if [ $HTTP_LIMIT_VAR = YES ]; then
+    have=NGX_HTTP_LIMIT_VAR . auto/have
+    HTTP_MODULES="$HTTP_MODULES $HTTP_LIMIT_VAR_MODULE"
+    HTTP_SRCS="$HTTP_SRCS $HTTP_LIMIT_VAR_SRCS"
+fi
+
 if [ $HTTP_LIMIT_REQ = YES ]; then
     HTTP_MODULES="$HTTP_MODULES $HTTP_LIMIT_REQ_MODULE"
     HTTP_SRCS="$HTTP_SRCS $HTTP_LIMIT_REQ_SRCS"
@@ -314,11 +320,21 @@ if [ $HTTP_FLV = YES ]; then
     HTTP_SRCS="$HTTP_SRCS $HTTP_FLV_SRCS"
 fi
 
+if [ $HTTP_IS_BOT = YES ]; then
+    HTTP_MODULES="$HTTP_MODULES $HTTP_IS_BOT_MODULE"
+    HTTP_SRCS="$HTTP_SRCS $HTTP_IS_BOT_SRCS"
+fi
+
 if [ $HTTP_UPSTREAM_IP_HASH = YES ]; then
     HTTP_MODULES="$HTTP_MODULES $HTTP_UPSTREAM_IP_HASH_MODULE"
     HTTP_SRCS="$HTTP_SRCS $HTTP_UPSTREAM_IP_HASH_SRCS"
 fi
 
+if [ $HTTP_RESPONSE = YES ]; then
+    HTTP_MODULES="$HTTP_MODULES $HTTP_RESPONSE_MODULE"
+    HTTP_SRCS="$HTTP_SRCS $HTTP_RESPONSE_SRCS"
+fi
+
 if [ $HTTP_STUB_STATUS = YES ]; then
     have=NGX_STAT_STUB . auto/have
     HTTP_MODULES="$HTTP_MODULES ngx_http_stub_status_module"
@@ -423,6 +439,18 @@ if [ $NGX_CPP_TEST = YES ]; then
     NGX_MISC_SRCS="$NGX_MISC_SRCS $NGX_CPP_TEST_SRCS"
 fi
 
+if [ $USE_OBSD_MALLOC = YES ]; then
+    have=OBSD_MALLOC . auto/have
+    USE_JEMALLOC=NO
+    CORE_SRCS="$CORE_SRCS $NGX_OBSD_MALLOC_SRCS"
+fi
+
+if [ $USE_JEMALLOC = YES ]; then
+    have=JEMALLOC . auto/have
+    USE_OBSD_MALLOC=NO
+    CORE_SRCS="$CORE_SRCS $NGX_JEMALLOC_SRCS"
+fi
+
 
 cat << END                                    > $NGX_MODULES_C
 
diff --git a/auto/options b/auto/options
index 3b3ee0f..bba4b70 100644
--- a/auto/options
+++ b/auto/options
@@ -41,6 +41,9 @@ EVENT_SELECT=NO
 EVENT_POLL=NO
 EVENT_AIO=NO
 
+USE_OBSD_MALLOC=NO
+USE_JEMALLOC=NO
+
 USE_THREADS=NO
 
 NGX_IPV6=NO
@@ -79,13 +82,16 @@ HTTP_FASTCGI=YES
 HTTP_PERL=NO
 HTTP_MEMCACHED=YES
 HTTP_LIMIT_ZONE=YES
+HTTP_LIMIT_VAR=YES
 HTTP_LIMIT_REQ=YES
 HTTP_EMPTY_GIF=YES
 HTTP_BROWSER=YES
 HTTP_SECURE_LINK=NO
+HTTP_IS_BOT=NO
 HTTP_FLV=NO
 HTTP_GZIP_STATIC=NO
 HTTP_UPSTREAM_IP_HASH=YES
+HTTP_RESPONSE=NO
 
 # STUB
 HTTP_STUB_STATUS=NO
@@ -129,6 +135,9 @@ USE_LIBGD=NO
 NGX_GOOGLE_PERFTOOLS=NO
 NGX_CPP_TEST=NO
 
+NGX_CLOCK=YES
+NGX_CLOCK_GETTIMEOFDAY=NO
+
 NGX_CPU_CACHE_LINE=
 
 opt=
@@ -166,6 +175,10 @@ do
         --without-poll_module)           EVENT_POLL=NONE            ;;
         --with-aio_module)               EVENT_AIO=YES              ;;
 
+        --with-obsd_malloc)              USE_OBSD_MALLOC=YES        ;;
+        --with-jemalloc)                 USE_JEMALLOC=YES           ;;
+
+
         #--with-threads=*)                USE_THREADS="$value"       ;;
         #--with-threads)                  USE_THREADS="pthreads"     ;;
 
@@ -187,9 +200,11 @@ do
         --with-http_sub_module)          HTTP_SUB=YES               ;;
         --with-http_dav_module)          HTTP_DAV=YES               ;;
         --with-http_flv_module)          HTTP_FLV=YES               ;;
+        --with-http_is_bot_module)       HTTP_IS_BOT=YES            ;;
         --with-http_gzip_static_module)  HTTP_GZIP_STATIC=YES       ;;
         --with-http_random_index_module) HTTP_RANDOM_INDEX=YES      ;;
         --with-http_secure_link_module)  HTTP_SECURE_LINK=YES       ;;
+        --with-http_response_module)     HTTP_RESPONSE=YES          ;;
 
         --without-http_charset_module)   HTTP_CHARSET=NO            ;;
         --without-http_gzip_module)      HTTP_GZIP=NO               ;;
@@ -207,6 +222,7 @@ do
         --without-http_fastcgi_module)   HTTP_FASTCGI=NO            ;;
         --without-http_memcached_module) HTTP_MEMCACHED=NO          ;;
         --without-http_limit_zone_module) HTTP_LIMIT_ZONE=NO        ;;
+        --without-http_limit_var_module) HTTP_LIMIT_VAR=NO         ;;
         --without-http_limit_req_module) HTTP_LIMIT_REQ=NO         ;;
         --without-http_empty_gif_module) HTTP_EMPTY_GIF=NO          ;;
         --without-http_browser_module)   HTTP_BROWSER=NO            ;;
@@ -231,6 +247,9 @@ do
         --with-google_perftools_module)  NGX_GOOGLE_PERFTOOLS=YES   ;;
         --with-cpp_test_module)          NGX_CPP_TEST=YES           ;;
 
+        --without-clock)                 NGX_CLOCK=NO               ;;
+        --with-clock_gettimeofday)       NGX_CLOCK_GETTIMEOFDAY=YES ;;
+
         --add-module=*)                  NGX_ADDONS="$NGX_ADDONS $value" ;;
 
         --with-cc=*)                     CC="$value"                ;;
@@ -303,6 +322,9 @@ cat << END
   --with-poll_module                 enable poll module
   --without-poll_module              disable poll module
 
+  --with-obsd_malloc                 enable obsd-like malloc
+  --with-jemalloc                    enable jemalloc
+
   --with-ipv6                        enable ipv6 support
 
   --with-http_ssl_module             enable ngx_http_ssl_module
@@ -313,10 +335,12 @@ cat << END
   --with-http_sub_module             enable ngx_http_sub_module
   --with-http_dav_module             enable ngx_http_dav_module
   --with-http_flv_module             enable ngx_http_flv_module
+  --with-http_is_bot_module          enable ngx_http_is_bot_module
   --with-http_gzip_static_module     enable ngx_http_gzip_static_module
   --with-http_random_index_module    enable ngx_http_random_index_module
   --with-http_secure_link_module     enable ngx_http_secure_link_module
   --with-http_stub_status_module     enable ngx_http_stub_status_module
+  --with-http_response_module        enable ngx_http_response_module
 
   --without-http_charset_module      disable ngx_http_charset_module
   --without-http_gzip_module         disable ngx_http_gzip_module
@@ -333,6 +357,7 @@ cat << END
   --without-http_fastcgi_module      disable ngx_http_fastcgi_module
   --without-http_memcached_module    disable ngx_http_memcached_module
   --without-http_limit_zone_module   disable ngx_http_limit_zone_module
+  --without-http_limit_var_module    disable ngx_http_limit_var_module
   --without-http_limit_req_module    disable ngx_http_limit_req_module
   --without-http_empty_gif_module    disable ngx_http_empty_gif_module
   --without-http_browser_module      disable ngx_http_browser_module
@@ -362,6 +387,9 @@ cat << END
   --with-google_perftools_module     enable ngx_google_perftools_module
   --with-cpp_test_module             enable ngx_cpp_test_module
 
+  --without-clock                    disable clock_gettime usage
+  --with-clock_gettimeofday          enable clock_gettimeofday usage if it possible
+
   --add-module=PATH                  enable an external module
 
   --with-cc=PATH                     set path to C compiler
@@ -370,7 +398,9 @@ cat << END
   --with-ld-opt=OPTIONS              set additional options for linker
   --with-cpu-opt=CPU                 build for specified CPU, the valid values:
                                      pentium, pentiumpro, pentium3, pentium4,
-                                     athlon, opteron, sparc32, sparc64, ppc64
+                                     prescott, nocona, core2, athlon, opteron,
+                                     opteron-sse3, opteron, sparc32, sparc64,
+                                     ppc64
 
   --without-pcre                     disable PCRE library usage
   --with-pcre                        force PCRE library usage
diff --git a/auto/os/linux b/auto/os/linux
index 0bd0488..6a3f69c 100644
--- a/auto/os/linux
+++ b/auto/os/linux
@@ -123,6 +123,8 @@ ngx_feature_test="long mask = 0;
                   sched_setaffinity(0, 32, (cpu_set_t *) &mask)"
 . auto/feature
 
+# capabilities
+. auto/lib/capabilities/conf
 
 # crypt_r()
 
diff --git a/auto/sources b/auto/sources
index e4649b0..6814cd0 100644
--- a/auto/sources
+++ b/auto/sources
@@ -23,8 +23,11 @@ CORE_DEPS="src/core/nginx.h \
            src/core/ngx_crc.h \
            src/core/ngx_crc32.h \
            src/core/ngx_md5.h \
+           src/core/ngx_lookup3.h \
            src/core/ngx_sha1.h \
            src/core/ngx_rbtree.h \
+           src/core/ngx_rbtreehash.h \
+           src/core/ngx_flathash.h \
            src/core/ngx_radix_tree.h \
            src/core/ngx_slab.h \
            src/core/ngx_times.h \
@@ -50,7 +53,10 @@ CORE_SRCS="src/core/nginx.c \
            src/core/ngx_inet.c \
            src/core/ngx_file.c \
            src/core/ngx_crc32.c \
+           src/core/ngx_lookup3.c \
            src/core/ngx_rbtree.c \
+           src/core/ngx_rbtreehash.c \
+           src/core/ngx_flathash.c \
            src/core/ngx_radix_tree.c \
            src/core/ngx_slab.c \
            src/core/ngx_times.c \
@@ -416,6 +422,10 @@ HTTP_LIMIT_ZONE_MODULE=ngx_http_limit_zone_module
 HTTP_LIMIT_ZONE_SRCS=src/http/modules/ngx_http_limit_zone_module.c
 
 
+HTTP_LIMIT_VAR_MODULE=ngx_http_limit_var_module
+HTTP_LIMIT_VAR_SRCS=src/http/modules/ngx_http_limit_var_module.c
+
+
 HTTP_LIMIT_REQ_MODULE=ngx_http_limit_req_module
 HTTP_LIMIT_REQ_SRCS=src/http/modules/ngx_http_limit_req_module.c
 
@@ -436,6 +446,10 @@ HTTP_FLV_MODULE=ngx_http_flv_module
 HTTP_FLV_SRCS=src/http/modules/ngx_http_flv_module.c
 
 
+HTTP_IS_BOT_MODULE=ngx_http_is_bot_module
+HTTP_IS_BOT_SRCS=src/http/modules/ngx_http_is_bot_module.c
+
+
 HTTP_GZIP_STATIC_MODULE=ngx_http_gzip_static_module
 HTTP_GZIP_STATIC_SRCS=src/http/modules/ngx_http_gzip_static_module.c
 
@@ -443,6 +457,9 @@ HTTP_GZIP_STATIC_SRCS=src/http/modules/ngx_http_gzip_static_module.c
 HTTP_UPSTREAM_IP_HASH_MODULE=ngx_http_upstream_ip_hash_module
 HTTP_UPSTREAM_IP_HASH_SRCS=src/http/modules/ngx_http_upstream_ip_hash_module.c
 
+HTTP_RESPONSE_MODULE=ngx_http_response_module
+HTTP_RESPONSE_SRCS=src/http/modules/ngx_http_response_module.c
+
 
 MAIL_INCS="src/mail"
 
@@ -484,3 +501,7 @@ NGX_GOOGLE_PERFTOOLS_MODULE=ngx_google_perftools_module
 NGX_GOOGLE_PERFTOOLS_SRCS=src/misc/ngx_google_perftools_module.c
 
 NGX_CPP_TEST_SRCS=src/misc/ngx_cpp_test_module.cpp
+
+NGX_OBSD_MALLOC_SRCS=src/os/unix/ngx_obsd_malloc.c
+
+NGX_JEMALLOC_SRCS=src/os/unix/ngx_jemalloc.c
diff --git a/src/core/nginx.c b/src/core/nginx.c
index eec48bf..9853bc6 100644
--- a/src/core/nginx.c
+++ b/src/core/nginx.c
@@ -154,6 +154,17 @@ static ngx_command_t  ngx_core_commands[] = {
 
 #endif
 
+#if (NGX_HAVE_CAPABILITIES)
+
+    { ngx_string("use_bind_capability"),
+      NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_FLAG,
+      ngx_conf_set_flag_slot,
+      0,
+      offsetof(ngx_core_conf_t, use_bind_capability),
+      NULL },
+
+#endif
+
       ngx_null_command
 };
 
@@ -202,6 +213,9 @@ main(int argc, char *const *argv)
     ngx_log_t        *log;
     ngx_cycle_t      *cycle, init_cycle;
     ngx_core_conf_t  *ccf;
+#if (NGX_HAVE_CAPABILITIES)
+    cap_value_t      cap_list[1];
+#endif
 
     if (ngx_get_options(argc, argv) != NGX_OK) {
         return 1;
@@ -336,6 +350,23 @@ main(int argc, char *const *argv)
 
     ccf = (ngx_core_conf_t *) ngx_get_conf(cycle->conf_ctx, ngx_core_module);
 
+#if (NGX_HAVE_CAPABILITIES)
+    if (!geteuid() && ccf->use_bind_capability) {
+        if (ngx_capabilities_prepare(log) != NGX_OK) {
+            return NGX_OK;
+        }
+
+        if (ngx_switch_user(cycle) != NGX_OK) {
+            return 1;
+        }
+
+        cap_list[0] = CAP_NET_BIND_SERVICE;
+        if (ngx_set_capability(log, 1, cap_list) != NGX_OK) {
+            return 1;
+	}
+    }
+#endif
+
     if (ccf->master && ngx_process == NGX_PROCESS_SINGLE) {
         ngx_process = NGX_PROCESS_MASTER;
     }
@@ -933,6 +964,10 @@ ngx_core_module_create_conf(ngx_cycle_t *cycle)
     ccf->thread_stack_size = NGX_CONF_UNSET_SIZE;
 #endif
 
+#if (NGX_HAVE_CAPABILITIES)
+    ccf->use_bind_capability = NGX_CONF_UNSET;
+#endif
+
     if (ngx_array_init(&ccf->env, cycle->pool, 1, sizeof(ngx_str_t))
         != NGX_OK)
     {
@@ -977,6 +1012,9 @@ ngx_core_module_init_conf(ngx_cycle_t *cycle, void *conf)
 
 #endif
 
+#if (NGX_HAVE_CAPABILITIES)
+    ngx_conf_init_value(ccf->use_bind_capability, 0);
+#endif
 
     if (ccf->pid.len == 0) {
         ccf->pid.len = sizeof(NGX_PID_PATH) - 1;
diff --git a/src/core/nginx.h b/src/core/nginx.h
index 22411be..9ee6a74 100644
--- a/src/core/nginx.h
+++ b/src/core/nginx.h
@@ -8,9 +8,9 @@
 #define _NGINX_H_INCLUDED_
 
 
-#define nginx_version         7057
-#define NGINX_VERSION      "0.7.57"
-#define NGINX_VER          "nginx/" NGINX_VERSION
+#define nginx_version         7056
+#define NGINX_VERSION      "0.7.57.422.152eb14"
+#define NGINX_VER          "nginx-catap/" NGINX_VERSION
 
 #define NGINX_VAR          "NGINX"
 #define NGX_OLDPID_EXT     ".oldbin"
diff --git a/src/core/ngx_core.h b/src/core/ngx_core.h
index d5f18b8..809bd71 100644
--- a/src/core/ngx_core.h
+++ b/src/core/ngx_core.h
@@ -75,6 +75,9 @@ typedef void (*ngx_connection_handler_pt)(ngx_connection_t *c);
 #include <ngx_open_file_cache.h>
 #include <ngx_os.h>
 #include <ngx_connection.h>
+#include <ngx_lookup3.h>
+#include <ngx_rbtreehash.h>
+#include <ngx_flathash.h>
 
 
 #define LF     (u_char) 10
diff --git a/src/core/ngx_cycle.h b/src/core/ngx_cycle.h
index e390588..3850fe4 100644
--- a/src/core/ngx_cycle.h
+++ b/src/core/ngx_cycle.h
@@ -103,6 +103,10 @@ typedef struct {
      size_t                   thread_stack_size;
 #endif
 
+#if (NGX_HAVE_CAPABILITIES)
+     ngx_flag_t               use_bind_capability;
+#endif
+
 } ngx_core_conf_t;
 
 
